
#include <stdlib.h>
#include <stdio.h>

	typedef struct numobj {
			int mynum;
			struct numobj *nextptr;
			} NUMOBJ;

 void printobj(NUMOBJ*);
 NUMOBJ* addobj(NUMOBJ*);
 NUMOBJ* delobj(NUMOBJ*);

 int main(void)
	{
	char choice[2];
	int more = 1;
	NUMOBJ * headptr = 0, *resptr;

	while (more != 0)
		{
		printf ("Please enter choice\n");
		scanf("%s", choice);
		switch(choice[0])
			{
			case 'a': 
					resptr = addobj(headptr);
					if(headptr== 0)
						headptr = resptr;
					break;
			case 'p':
					printobj(headptr);
					break;
			case 'd':
					if(headptr != 0)
						{
						resptr = delobj(headptr);
						if(resptr == 0)
							headptr = 0;
						}
					break;
			case 'q':
					more = 0;
			}
		}
	return 0;
	}

void printobj(NUMOBJ *objptr)
	{
	if(objptr != 0)
		{
		printf ("%d\n", objptr->mynum);
		printobj(objptr->nextptr);
		}
	}


NUMOBJ *addobj(NUMOBJ *objptr)
	{
	NUMOBJ*newptr, *resptr;

	if(objptr == 0)
		{
		newptr = (NUMOBJ*) malloc(sizeof(NUMOBJ));
		newptr->nextptr = 0;
		printf("Please enter new number\n");
		scanf("%d", &newptr->mynum);
		return newptr;
		}
	else
		{
		resptr = addobj(objptr->nextptr);
		if(resptr != 0)
			objptr->nextptr = resptr;
		return 0;
		}
	}

NUMOBJ *delobj(NUMOBJ *objptr)
	{
	NUMOBJ *resptr;

	if(objptr->nextptr == 0)
		{
		free (objptr);
		return 0;
		}
	else
		{
		resptr= delobj(objptr->nextptr);
		if(resptr == 0)
			objptr->nextptr = 0;
		return objptr;
		}
	}



