
	struct OBJ {
			void *recptr;
			OBJ *nextptr;
			};

	class list {
		private:
			OBJ *headptr;
			void printobj(OBJ*);
			OBJ* addobj(OBJ*, OBJ*);
 			OBJ* delobj(OBJ*);
		protected:
			void printlist(void);
 			void addlist(void*);
			void dellist(void);
		public:
			list(void);
			virtual void printrec(void*);
			virtual void deleterec(void*);
		};
 
	list::list(void)
	{
	headptr = 0;
	}

void list::printrec(void * rptr)
	{
	printf("record");
	}

void list::deleterec(void * rptr)
	{
	delete rptr;
	}

void list::printlist(void)
	{
	printobj(headptr);
	}

void list::printobj(OBJ *objptr)
	{
	if(objptr != 0)
		{
		printrec(objptr->recptr);
		printobj(objptr->nextptr);
		}
	}

void list::addlist( void *recptr)
	{
	OBJ *resptr;
	OBJ *newptr;
	
	newptr = new OBJ;
	newptr->recptr = recptr;
	resptr = addobj(headptr, newptr);
		if(headptr== 0)
				headptr = resptr;
	}

OBJ * list::addobj(OBJ *objptr, OBJ *newptr)
	{
	OBJ *resptr;

	if(objptr == 0)
		{
		newptr->nextptr = 0;
		return newptr;
		}
	else
		{
		resptr = addobj(objptr->nextptr, newptr);
		if(resptr != 0)
			objptr->nextptr = resptr;
		return 0;
		}
	}

void list::dellist()
	{
	OBJ *resptr;
	if(headptr != 0)
		{
		resptr = delobj(headptr);
		if(resptr == 0)
			headptr = 0;
		}
	}

OBJ* list::delobj(OBJ *objptr)
	{
	OBJ *resptr;

	if(objptr->nextptr == 0)
		{
		deleterec(objptr->recptr);
		delete objptr;
		return 0;
		}
	else
		{
		resptr= delobj(objptr->nextptr);
		if(resptr == 0)
			objptr->nextptr = 0;
		return objptr;
		}
	}


