
#include <stdio.h>
#define MARGIN 0.05

/* Function Declarations */
void user_input(double*, double* );
void calc_price( double, double* );
void calc_profit( double, double, double* );


int main(void)
	{
	double price, cost, profit, wholesale_price;
	int response = 'y';

	while (response != 'n'){
		user_input(&cost, &wholesale_price);
		calc_price(wholesale_price, &price);
		calc_profit(cost, price, &profit);
		printf("Profit = %.2f\n", profit);
		printf("Do you wish to continue:");
		response = getchar();
		}
	return 0;
	}

void user_input(double *costptr,double *wh_ptr)
	{
	printf("\nPlease enter cost: ");
	scanf ("%lf", costptr);
	printf("\nPlease enter wholesale price: ");
	scanf ("%lf", wh_ptr);
	while (getchar() !='\n');
	}

void calc_price (double w_price,double *priceptr )
	{
	*priceptr = w_price + (w_price * MARGIN);
	}

void calc_profit(double cost, double price,
		double *profitptr)
	{
	*profitptr = (price - cost);
	}



