#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "types.h"

 static NODE *rootptr;
 static void printorder(NODE*, EMP[]);
 static void printnodes(NODE*);
 static NODE *addnode(NODE*, char*,int);


 void printrecords (EMP emps[])
	{
	printorder(rootptr,emps);
	}

static void printorder(NODE *nodeptr, EMP emps[])
	{
	if(nodeptr != 0)
		{
		printorder(nodeptr->lptr,emps);
		printrec(nodeptr->recno, emps);
		printorder(nodeptr->rptr, emps);
		}
	}

 void printindex(void)
	{
	printnodes(rootptr);
	}

static void printnodes(NODE *nodeptr)
	{
	if(nodeptr != 0)
		{
		printf("\n%d", nodeptr->recno);
		printf("\n%s\n", nodeptr->name);
		printnodes(nodeptr->lptr);
		printnodes(nodeptr->rptr);
		}
	}

 void addindex(char *name, int recno)
	{
	NODE *resptr;
	
	resptr = addnode(rootptr, name, recno);
	if(rootptr == 0)
		rootptr = resptr;
	}

 static NODE *addnode(NODE *nptr, char *name, int recno)
	{
	NODE *newptr = 0, *resptr;

	if(nptr == 0)
		{
		newptr = (NODE*) malloc(sizeof(NODE));
		strcpy (newptr->name, name);
		newptr->recno = recno;
		newptr->rptr = 0;
		newptr->lptr = 0;
		return newptr;
		}
	else
		{
		if(strcmp(name, nptr->name) < 0)
			{
			resptr = addnode(nptr->lptr,name,recno);
			if(resptr != 0)
				nptr->lptr = resptr;
			}
		else
			if(strcmp(name, nptr->name) > 0)
				{
			resptr=addnode(nptr->rptr,name,recno);
				if(resptr != 0)
					nptr->rptr = resptr;
				}
		return 0;
		}
	}


