
#include <stdio.h>
#include "emp.h"
#include "file.h"

#define NAMELEN 100

/* EMP structure */
	typedef  struct emp_type {
		char name[NAMELEN];
		long id;
		float salary;
		} EMP;

 static EMP input_rec(void);
 static void output_rec(EMP);

 void open_empfile(char* filename)
	{
	openfile(filename, sizeof(EMP));
	}

 void close_empfile(void)
	{
	closefile();
	}

void add_rec(void)
	{
	EMP emprec;
	
	emprec = input_rec();
	emprec.id = setnextrecno();
	writerec((char*)&emprec, emprec.id);
	}

 static EMP input_rec(void)
		{
		EMP in_emp;

		printf("\nPlease enter name: ");
		scanf("%*[\n\t ]%[^\n]s", in_emp.name);
		printf("Please enter salary: ");
		scanf("%f", &in_emp.salary);
		return(in_emp);
		}

void print_recs(void)
		{
		EMP emprec;
		long i, lastrec;

		lastrec = getlastrecno();
		for (i = 1; i <= lastrec ; i++){
			readrec((char*)&emprec,i);
			output_rec(emprec);
			}
		}

 static void output_rec(EMP out_emp)
		{
		printf("\n Employee Record \n");
		printf("\t NAME  : %s\n", out_emp.name);
		printf("\t ID    : %ld\n", out_emp.id);
		printf("\t SALARY: %.2f\n", out_emp.salary);
		}


