
#include <stdio.h>

#include "recfile.h"

	struct EMP {
		char name[100];
		long id;
		double salary;
		};

	class emp {
		private:
			EMP emprec;
			recfile empfile;
			void input_rec();
			void output_rec();
		public:
			 emp(char*);
			~emp();
			void add_rec();
			void print_rec();
			void find_rec( void);
		};

	  emp::emp(char *filename):empfile(sizeof(EMP))
		{
		empfile.openfile(filename);
		}

	  emp::~emp()
		{
		empfile.closefile();
		}

	void emp::add_rec()
		{
		input_rec();
		empfile.writerec( &emprec);
		}

	void emp::input_rec()
		{
		printf("\nPlease enter last name: ");
		scanf("%*[\n\t ]%[^\n]s", emprec.name);
		printf("\nplease enter employee id: ");
		scanf("%ld", &emprec.id);
		printf("\nplease enter employee salary: ");
		scanf("%lf", &emprec.salary);
		}

	void emp::print_rec()
		{
		empfile.reset();
		while( empfile.readrec(&emprec) != 0)
			{
			output_rec();
			}
		}

	void emp::output_rec()
		{
		printf("\n\n Employee Record \n");
		printf("\n\t NAME  : %s \n", emprec.name);
		printf("\n\t ID    : %ld \n", emprec.id);
		printf("\n\t SALARY: %f \n\n", emprec.salary);
		}

	void emp::find_rec( void)
		{
		long id;

		printf("Please enter record id: ");
		scanf("%ld", &id);
		empfile.reset();
		while  ( (empfile.readrec(&emprec) != 0)
							&& (id != emprec.id));

		if (id == emprec.id )
			output_rec();
		 else
			printf("Record not found\n");
		}



