
#include <stdio.h>
#define MARGIN 0.05

/* Function Declarations */
double input_cost(void);   
double input_wholesale(void);
double calc_price(double);
double calc_profit(double, double);

int main(void)
	{
	double price, cost, profit, wholesale_price;
	char response = 'y';

	while (response != 'n'){
		cost = input_cost();
		wholesale_price = input_wholesale();
		price = calc_price( wholesale_price );
		profit = calc_profit( cost, price );
		printf("Profit = %.2f\n", profit);
		printf("Do you wish to continue:");
		while (getchar() != '\n');
		response = getchar();
		}
	return 0;
	}

double input_cost(void)
	{
	double  user_cost;
	printf("\nPlease enter cost: ");
	scanf ("%lf", &user_cost);
	return (user_cost);
	}

double input_wholesale(void)
	{
	double  user_wholesale;
	printf("\nPlease enter wholesale price: ");
	scanf ("%lf", &user_wholesale);
	return (user_wholesale);
	}

double calc_price (double w_price)
	{
	double  calc_price;
	calc_price = w_price + (w_price * MARGIN);
	return (calc_price);
	}

double calc_profit (double cost, double price)
	{
	return (price - cost);
	}


